/*
    AltBandColor.cc
    Author: Ken Mayer
    Date..: February 22, 2005
    Notes.: This creates an alternating color for the detailBand
            of a report. I have not tested in all situations
            for possible issues, but at a quick test, it appears
            to work ...

            It's not a good idea to use this on a form!

    It's important to note that this class requires 
    that:
      a) it be the first on the detailBand in the z-order,
         which may require moving it in the Source Code;
      b) text controls placed on top of it have their 
         transparent property set to true'
      c) the name of the streamFrame is "streamFrame1";
      d) the name of the pageTemplate is "pageTemplate1"

    To use this, place it on the detailBand of a report, then place
    controls on top of this one. This has a single character value for
    the text property, and that's all that's needed. When run, it
    will calculate whether or not to display ...
*/
class AltBandColorText( oParent ) of text( oParent ) custom
   this.text        = " "
   // Change the background color here ...
   this.colorNormal = "black/0xd8e9ec" 

   function onOpen
      this.top    := 0
      this.left   := 0
                     // use detailBand height
      this.height := this.parent.height
                     // use streamFrame width
      this.width  := form.pageTemplate1.streamFrame1.width
   return

   function canRender
      local bReturn
      // am not sure if I need these, but was hoping that 
      // in a report where the height of the detailBand changes,
      // this would be useful. So far, I can't seem to see any
      // change, so this may only work on a static band height ...
                     // use detailBand height
      this.height := this.parent.height
                     // use streamFrame width
      this.width  := form.pageTemplate1.streamFrame1.width

      // this is vital: we create a simple counter,
      // and increment it before rendering ...
      if type("this.counter") == "U"
         this.counter = 1
      else
         this.counter++
      endif

      // even number? If so, display, if odd number don't!
      if (this.counter/2) == int(this.counter/2)
         bReturn = true
      else
         bReturn = false
      endif
   return bReturn
endclass
