/*
   ----------------------------------------------------------------------------
   TestSocketWrench.prg
   A sample dBL program from 
   The dBASE Book Plus by Kenneth J. Mayer. 
   Program copyright 2015. 
   Permission is granted for use as a learning tool for dBASE Plus.
   Sample from: Chapter 12
        
   This program shows each of the standard Catalyst Controls, and
   when run shows which are available to you on your installation
   of dBASE. The odds are you will end up with only five of these
   that are usable:
        FTP Client (File Transfer)
        HTTP Client (Hypertext Transfer)
        SMTPClient (Simple Mail Transfer)
        POPClient (Post Office)
        SocketWrench
   
   This is based on a program by Bernard Mouille posted in the newsgroups.
   ----------------------------------------------------------------------------
*/
// check version of dBASE ...:
if val( right( version(),4) ) < 9
   msgbox( "You must be using dBASE 9 or later "+;
	        "to run this form ...",;
			  "Wrong Version of dBASE", 16 )
   return
endif

/*
   csdnsax8.ocx   SocketTools.DnsClient.8     Domain Name Service Control 
   csfgrax8.ocx   SocketTools.FingerClient.8  Finger Protocol Control 
   csftpax8.ocx   SocketTools.FtpClient.8     File Transfer Protocol Control 
   csftsax8.ocx   SocketTools.FtpServer.8     File Transfer Server Control 
   csgprax8.ocx   SocketTools.GopherClient.8  Gopher Protocol Control 
   cshtpax8.ocx   SocketTools.HttpClient.8    Hypertext Transfer Protocol Control 
   cshtsax8.ocx   SocketTools.HttpServer.8    Hypertext Transfer Server Control 
   csicmax8.ocx   SocketTools.IcmpClient.8    Internet Control Message Protocol Control 
   csmapax8.ocx   SocketTools.ImapClient.8    Internet Message Access Protocol Control 
   csmsgax8.ocx   SocketTools.MailMessage.8   Mail Message Control   // Not registry.
   csmtpax8.ocx   SocketTools.SmtpClient.8    Simple Mail Transfer Protocol Control // Registry
   csncdax8.ocx   SocketTools.FileEncoder.8   File Encoding Control 
   csnvtax8.ocx   SocketTools.Terminal.8      Terminal Emulation Control 
   csnwsax8.ocx   SocketTools.NntpClient.8    Network News Transfer Protocol Control 
   cspopax8.ocx   SocketTools.PopClient.8     Post Office Protocol Control // Registry
   csrasax8.ocx   SocketTools.Dialer.8        Remote Access Services Dialer Control // Not registry.
   csrshax8.ocx   SocketTools.RshClient.8     Remote Command Protocol Control 
   csrssax8.ocx   SocketTools.NewsFeed.8      Syndicated News Feed Control 
   cstimax8.ocx   SocketTools.TimeClient.8    Time Protocol Control 
   cstntax8.ocx   SocketTools.TelnetClient.8  Telnet Protocol Control 
   cstshax8.ocx   SocketTools.SshClient.8     Secure Shell Protocol Control 
   cstxtax8.ocx   SocketTools.TextMessage.8   Text Messaging Control // Not registry.
   cswhoax8.ocx   SocketTools.WhoisClient.8   Whois Protocol Control 
   cswskax8.ocx   SocketTools.SocketWrench.8  Windows Sockets (SocketWrench) Control // Registry
*/

*
CLEAR                                          // Clear the Command Window output pane
*
? "Start the Program"
*
TestOLE8( "SocketTools.DnsClient.8" )
TestOLE8( "SocketTools.FingerClient.8" )
TestOLE8( "SocketTools.FtpClient.8" )
TestOLE8( "SocketTools.FtpServer.8" )
TestOLE8( "SocketTools.GopherClient.8" )
TestOLE8( "SocketTools.HttpClient.8" )
TestOLE8( "SocketTools.HttpServer.8" )
TestOLE8( "SocketTools.IcmpClient.8" )
TestOLE8( "SocketTools.ImapClient.8" )
TestOLE8( "SocketTools.MailMessage.8" )
TestOLE8( "SocketTools.SmtpClient.8" )
TestOLE8( "SocketTools.FileEncoder.8" )
TestOLE8( "SocketTools.Terminal.8" )
TestOLE8( "SocketTools.NntpClient.8" )
TestOLE8( "SocketTools.PopClient.8" )
TestOLE8( "SocketTools.Dialer.8" )
TestOLE8( "SocketTools.RshClient.8" )
TestOLE8( "SocketTools.NewsFeed.8" )
TestOLE8( "SocketTools.TimeClient.8 " )
TestOLE8( "SocketTools.TelnetClient.8" )
TestOLE8( "SocketTools.SshClient.8" )
TestOLE8( "SocketTools.TextMessage.8" )
TestOLE8( "SocketTools.WhoisClient.8" )
TestOLE8( "SocketTools.SocketWrench.8" )
*
?
WAIT "End of the program , press a key."  
*
RETURN
*
* -----------------------------------
FUNCTION TestOLE8( cOLE )
* -----------------------------------
*
LOCAL oSmtp
*
? cOLE, "=> "
*
TRY
 oSmtp = new OleAutoClient( cOLE )
 ?? "OK"
 oSmtp := null
CATCH ( Exception e )
 ?? "No"
ENDTRY
*
RETURN null

