/*
   ----------------------------------------------------------------------------
   MyHTML.cc
   Sample code from The dBASE Reports Book, second edition
   Chapter 23
   Copyright  2016, Kenneth J. Mayer
   
   A custom class for generating an HTML Report or file from
   dBASE Plus.
   
   This may be used for other purposes, as needed. 
   ----------------------------------------------------------------------------
*/

class MyHTML
   // spacing at the beginning of the lines
   // should insert the same spacing in the
   // output file.
   
   // custom properties for indentation:
   this.cTab = "   " // three spaces
   this.cTab2 = this.cTab+this.cTab  // double
   this.cTab3 = this.cTab2+this.cTab // triple
   this.cTab4 = this.cTab3+this.cTab // quadruple
   this.cTab5 = this.cTab4+this.cTab // quintuple
   
   function Header( cTitle )
      local cText
      cText  = this.cTab+[<head>]+chr(13)
      cText += this.cTab2+[<title>]+cTitle+[</title>]+chr(13)
      cText += this.cTab+[</head>]+chr(13)
   return cText
   
   function MainHeader( cHeader )
      local cText
      // The combinations of this.cTab (and so on) and chr(13)
      // help with indentation of the HTML for readability,
      // and making sure each statement is on its own line.
      
      // center it:
      cText = this.cTab2+[<center>]+chr(13)
      
      // Font: Arial, 20pt, italic:
      cText += this.cTab3+;
               [<span style="font-family: Arial; ]+;
                [font-size: 20pt; ]+;
                [font-style: italic;">]+chr(13)
      
      // if a value is passed don't use the
      // default:
      if not empty( cHeader )
         cText += this.cTab4+;
                  cHeader+chr(13)
      else
         cText += this.cTab4+;
                  "My Company Name"+chr(13)
      endif
      cText += this.cTab3+[</span>]+chr(13)
      cText += this.cTab2+[</center>]+chr(13)
   return cText

   function SecondaryHeader( cHeader )
      local cText
      // center it:
      cText = this.cTab2+[<center>]+chr(13)
      
      // Font: Arial, 16pt:
      cText += this.cTab3+;
               [<span style="font-family: Arial; ]+;
               [font-size: 16pt;">]+chr(13)
      
      // if a value is passed don't use the
      // default:
      if not empty( cHeader )
         cText += this.cTab4+;
                  cHeader+chr(13)
      else
         cText += this.cTab4+;
                  "Purpose of Report"+chr(13)
      endif
      cText += this.cTab3+[</span>]+chr(13)
      cText += this.cTab2+[</center>]+chr(13)
   return cText

   function DateText
      local cText
      // center it:
      cText = this.cTab2+[<center>]+chr(13)
      
      // Font: Arial, 12pt:
      cText += this.cTab3+;
               [<span style="font-family: Arial; ]+;
               [font-size: 12pt;">]+chr(13)

      // build the date:
      cText += this.cTab4
      cText += "Date: "+cmonth(date())+" "+day(date())+", "+year(date())
      cText += chr(13)
      cText += this.cTab3+[</span>]+chr(13)
      cText += this.cTab2+[</center>]+chr(13)   
   return cText
   
endclass
