/* 
   Code posted by Peter in the dBASE2000 newsgroups,
   April 28, 1999

*/
Function TypeOfObject
   param o  // An object
   //
   // Returns an upper case string describing the name
   // of the base class (the one at the top of the
   // inheritance tree) of object o.
   // By Peter Rorlick
   //
   do case  // The order of the cases is vital.
      case type('o.BaseClassName') == 'C'
           // If this custom property exists, use it.
           // (Esp. to distinguish between a subclassed
           // RadioButton and a subclassed Checkbox.)
           return upper(o.BaseClassName)
      case type('o.ReportGroup') == 'O'
           return 'REPORT'
      case type('o.InDesign') == 'L'
           return 'FORM'
      case type('o.rotate') == 'N'
           return 'TEXT'
      case Type('o.First')=='O' and type('o.UseTablePopUp')=='U'
           if type('o.datasource') == 'C'
              return 'NOTEBOOK'
           else
              return 'CONTAINER'
           endif
      case type('o.columns') == 'O'
           return 'GRID'
      case type('o.SpeedBar') == 'L'
           return 'PUSHBUTTON'
      case type('o.PatternStyle') == 'N'
           return 'RECTANGLE'
      case type('o.EvalTags') == 'L'
           return 'EDITOR'
      case type('o.Multiple') == 'L'
           return 'LISTBOX'
      case type('o.DropDownHeight') == 'N'
           return 'COMBOBOX'
      case type('o.alias') == 'C'
           return 'BROWSE'
      otherwise
           return o.className
   endcase

// End of Function: TypeOfObject()
