/*
   TestFish.prg
   A sample dBL program from 
   The dBASE Book
   by Kenneth J. Mayer. 
   Program copyright 2005-2007. 
   Permission granted for use as a learning tool for dBASE Plus.

   Sample from: Chapter 6 
   Simple example of working with the canSave event of the rowset
   with an event handler in a separate function.

// assumes that the command:
//    open database dbasesamples
// was issued in the Command Window
*/
q = new query()
q.sql := "select * from :dbasesamples:MyFish"
q.active := true

? q.rowset.fields[ "name"].value

q.rowset.canSave := ValidateData

q.rowset.fields["name"].value := ""
q.rowset.save()

q.rowset.fields["name"].value := "This is a test"
q.rowset.save()

? q.rowset.fields["name"].value

function ValidateData
   local bReturn
   bReturn = true
   if empty( q.rowset.fields["name"].value )
      ? "Name is empty -- this is not valid!"
      bReturn = false
   endif
return bReturn
