/*
   MyFormControls.cc
   A sample dBL custom class file from 
   The dBASE Book
   by Kenneth J. Mayer. 
   Program copyright 2005-2012. 
   Permission granted for use as a learning tool for dBASE Plus.

   Some basic custom classes for use in different parts of the book.
*/

class MYTEXTLABEL(parentObj) of TEXTLABEL(parentObj) custom
   with (this)
      height = 22.0
      left = 25.0
      top = 44.0
      width = 111.0
      metric = 6	// Pixels
      text = "MyTextLabel:"
      fontBold = true
      alignHorizontal = 2	// Right
   endwith

endclass

class MYENTRYFIELD(parentObj) of ENTRYFIELD(parentObj) custom
   with (this)
      height = 22.0
      left = 41.0
      top = 79.0
      width = 119.0
      metric = 6	// Pixels
      colorHighLight = "WindowText/0x80ffff"
      value = "MyEntryfield"
   endwith

endclass

class MYSPINBOX(parentObj) of SPINBOX(parentObj) custom
   with (this)
      height = 22.0
      left = 45.0
      top = 128.0
      width = 56.0
      metric = 6	// Pixels
      colorHighLight = "WindowText/0x80ffff"
      rangeMax = 100
      rangeMin = 1
      value = 1
   endwith

endclass

class MYEDITOR(parentObj) of EDITOR(parentObj) custom
   with (this)
      height = 88.0
      left = 33.0
      top = 178.0
      width = 140.0
      metric = 6	// Pixels
      value = ""
      colorHighLight = "WindowText/0x80ffff"
      evalTags = false
   endwith

endclass

class MYIMAGE(parentObj) of IMAGE(parentObj) custom
   with (this)
      height = 88.0
      left = 35.0
      top = 269.0
      width = 84.0
      metric = 6	// Pixels
      alignment = 3	// Keep Aspect Stretch
   endwith

endclass

class MYPUSHBUTTON(parentObj) of PUSHBUTTON(parentObj) custom
   with (this)
      height = 24.0
      left = 30.0
      top = 62.0
      width = 107.0
      text = "MyPushbutton"
      metric = 6	// Pixels
   endwith

   function onMouseOver
      this.fontBold := true
   return

   function onMouseOut
      this.fontBold := false
   return

endclass

