/*
   MyHTML.cc
   A sample dBL report from 
   The dBASE Reports Book
   by Kenneth J. Mayer. 
   Program copyright 2007. 
   Permission granted for use as a learning tool for dBASE Plus.

   Sample from: Chapter 22
   A custom class for generating an HTML Report or file from
   dBASE Plus.
*/
class MyHTML

   // we need to have some methods here that will stream out
   // specific things, depending on our needs for our reports.

   function Header( cTitle )
      local cText
      cText  = [<head>]+chr(13)
      cText += [   <title>]+cTitle+[</title>]+chr(13)
      cText += [</head>]+chr(13)
   return cText

   function MainHeader( cHeader )
      local cText
      // center it:
      cText  = [<center>]
      // Font: Arial, 20pt, italic:
      cText += [<span style="font-family: Arial; ]+;
               [font-size: 20pt; ]+;
               [font-style: italic;">]
      // if a value is passed don't use the
      // default:
      if not empty( cHeader )
         cText += cHeader
      else
         cText += "My Company Name"
      endif
      cText += [</span></center>]
   return cText

   function SecondaryHeader( cHeader )
      local cText
      // center it:
      cText  = [<center>]
      // Font: Arial, 16pt:
      cText += [<span style="font-family: Arial; ]+;
               [font-size: 16pt;">]
      // if a value is passed don't use the
      // default:
      if not empty( cHeader )
         cText += cHeader
      else
         cText += "Purpose of Report"
      endif
      cText += [</span></center>]
   return cText

   function DateText
      local cText
      // center it:
      cText  = [<center>]
      // Font: Arial, 12pt:
      cText += [<span style="font-family: Arial; ]+;
               [font-size: 12pt;">]
      cText += "Date: "+cmonth(date())+" "+day(date())+", "+year(date())
      cText += [</span></center>]
   return cText

endclass