/* Rich - www.autotraker.com
   This function will return the public IP of your machine by 
   connecting to a remote third party machine on the internet. 
   Also this function defaults to using AUTOTRAKER. I will continue 
   to supply IP information unless the volume gets too high. 
   I would suggest finding a whoami server that doesn't mind large 
   volumes of hits and willing to give you permission. 
   Other possible whoami servers you may find useful are below.

   Usage:
   ? getPublicIP() 					 // use default - AUTOTRAKER
   ? getPublicIP("UMD") 			 // University of Maryland
   ? getPublicIP("SMYIP") 			 // ShowMyIP.com - They allow 200 hits per day per IP unless you subscribe.
   ? getPublicIP("SMYIPXML") 		 // ShowMyIP.com, XML format
   ? getPublicIP("DSLRT")			 // DSL Reports
   ? getPublicIP("DNSSTUFF")  	 // DNS Stuff
   ? getPublicIP("KINGS")     	 // King's College London
   ? getPublicIP("DYNDNS")    	 // Dynamic Network Services, Inc
   ? getPublicIP("WEBCOGS")   	 // Webcogs is a thriving IT Solutions company based in the UK
   ? getPublicIP("UCI")       	 // University of California
   ? getPublicIP("FAQS")      	 // Internet FAQ Archives
   ? getPublicIP("UPENN")     	 // University of Pennsylvania
   ? getPublicIP("BIOMED")    	 // BioMed Central
   ? getPublicIP("SUNY")      	 // Stony Brook/SUNY University

   ? getPublicIP("TRUESHOT")  	 // George Burt (See below)
   ? getPublicIP("ALLDBASE")  	 // owned by AutoTraker Inc.
   ? getPublicIP("AUTOTRAKER")	 // owned by AutoTraker Inc.
   ? getPublicIP("AUTOCONTROLLER")// owned by AutoTraker Inc.
   ? getPublicIP("RIGGORY")	    // owned by AutoTraker Inc.

   http://www.rleeden.no-ip.com/geotool.php

   Web sites; ALLDBASE, AUTOTRAKER, AUTOCONTROLLER, & RIGGORY are all trademarks of and copyrighted
   by AutoTraker Inc., The use of these sites for the purposes of this application is limited and
   reserved and not guaranteed. In other words, you can use these sites for this applicaion only
   and I'll not guaranteed they will continue working forever.  

   TRUESHOT is owner by George Burt and you should get permission to use it for this purpose via
   the dBASETalk newsgroup as you should get permission from any of these sites before using for
   this application. Most are public sites and probaby fine to use. 

   If you find other sites that will show your IP address, it would be simple enough to add them.
   Just follow the code. 

*/
function getPublicIP
	parameters cUse

   if pCount() < 1 or not type("cUse")=="C" or empty(cUse) 
   	cUse = "AUTOTRAKER"
   endif

   if cUse == "UMD"
      baseURL = "http://noc.net.umd.edu/cgi-bin/netmgr/whoami" // University of Maryland
   elseif cUse == "SMYIP"
      baseURL = "http://www.showmyip.com/simple"
   elseif cUse == "SMYIPXML"
      baseURL = "http://www.showmyip.com/xml"
	elseif cUse == "DSLRT"
   	baseURL = "http://www.dslreports.com/ip"
   elseif cUse == "DNSSTUFF"
      baseURL = "http://www.dnsstuff.com/tools/aboutyou.ch"
   elseif cUse == "KINGS"
      baseURL = "http://www.kcl.ac.uk/webteam/ipaddress"  		// King's College London
   elseif cUse == "DYNDNS"
      baseURL = "http://checkip.dyndns.org" 							// Dynamic Network Services, Inc
   elseif cUse == "WEBCOGS" 												
      baseURL = "http://www.webcogs.com/whatsmyipaddress.aspx" // Webcogs is a thriving IT Solutions company based in the UK
   elseif cUse == "UCI"
      baseURL = "http://www.nacs.uci.edu/ipaddress.php" 			// University of California
   elseif cUse == "FAQS"
      baseURL = "http://www.faqs.org/ip.php" 						// Internet FAQ Archives
   elseif cUse == "UPENN"
      baseURL = "http://ccat.sas.upenn.edu/cgi-bin/elew/ip.cgi?Guest=+Click+here+to+view+your+IP+address+and+host+name+"  // University of Pennsylvania
   elseif cUse == "BIOMED"
      baseURL = "http://www.biomedcentral.com/whatsmyip.asp" 	// BioMed Central see http://www.biomedcentral.com/
   elseif cUse == "SUNY"
      baseURL = "http://www.sinc.sunysb.edu/cgi-bin/MyIP" 		// Stony Brook/SUNY University
   elseif cUse == "TRUESHOT"
      baseURL = "http://www.trueshot.com/ip" 						// George Burt
   elseif cUse == "ALLDBASE"
      baseURL = "http://www.alldbase.com/cgi-bin/counter.dbw"
   elseif cUse == "AUTOTRAKER"
      baseURL = "http://www.alldbase.com/cgi-bin/counter.dbw"
   elseif cUse == "AUTOCONTROLLER"
      baseURL = "http://www.autocontroller.com/cgi-bin/counter.dbw"
   elseif cUse == "RIGGORY"
      baseURL = "http://www.riggory.com/cgi-bin/counter.dbw"
	else
   	cUse = "AUTOTRAKER"
      baseURL = "http://www.alldbase.com/cgi-bin/counter.dbw"
	endif

//"
   // find and initialize the control
   preFixes = { "MSXML3", "MSXML2", "Microsoft", "MSXML"}
   for nPrefix = 1 to preFixes.size
      try
      	//? preFixes[nPrefix]
         objHTTP = new OleAutoClient(preFixes[nPrefix]+".XmlHttp")
         exit
      catch(exception e)
      	//? e.message
      endtry
   endfor  

   //? type("objHTTP")=="O"
       	
   // see if the control has a readyState
   // if not, it didn't load
   try
      if not type("objHTTP")=="O" or objHTTP.readyState <> 0
      	//? "ERROR Occurred throw e"
         throw e
      endif
   catch(exception e)
         msgbox("Can not load the HTTP Parser control","Error!",16)
         return "ERROR Occurred : " + e.message
   endtry	

   objHttp.open( "GET", baseURL , false)
   objHttp.setRequestHeader("Content-Type","application/x-www-form-urlencoded")
   objHttp.send()

	if objHttp.Status >= 400 and objHttp.Status <= 599
  		cPage = "ERROR Occurred : " + objHttp.Status + " - " + objHttp.statusText
   elseif objHttp.status = 200 // no error
      cPage = objHttp.responseText
   else
      cPage = "ERROR: " + objHttp.status
   endif
   release object objHttp

   IP = ""
   RDNS = ""
   // parse page for IP address
   if not cPage.left(5)=="ERROR"

      if cUse == "UMD"
         IP = cPage.substring(cPage.indexOf(":")+2,cPage.indexOf("(")-1) 
         RDNS = cPage.substring(cPage.indexOf("(")+1,cPage.indexOf(")")) 

      elseif cUse == "SMYIP"
         IP = cPage.left(cPage.indexOf("(")-1)

         // we can grab RDNS from this also

		elseif cUse == "SMYIPXML"
	      IP = cPage.substring(cPage.indexOf("<ip>")+4,cPage.indexOf("</ip>"))	

	      RDNS = cPage.substring(cPage.indexOf("<host>")+6,cPage.indexOf("</host>"))	

      elseif cUse == "DSLRT"
         cStr = "The IP that just fetched this page is<br>"
         cPage = cPage.substring(cPage.indexOf(cStr)+cStr.length,cPage.length) 
	      IP = cPage.left(cPage.indexOf("<br>"))	

      elseif cUse == "DNSSTUFF"
			cStr = "Your IP:</TD><TD>"
         cPage = cPage.substring(cPage.indexOf(cStr)+cStr.length,cPage.length) 
  	      IP = cPage.left(cPage.indexOf(" "))	

      elseif cUse == "KINGS"
         cStr = "Your Ip Address:</strong><br><br>"
         cPage = cPage.substring(cPage.indexOf(cStr)+cStr.length+1,cPage.length) 
  	      IP = cPage.left(cPage.indexOf("</p>"))	

      elseif cUse == "DYNDNS"
      	cStr = "Current IP Address: "
         cPage = cPage.substring(cPage.indexOf(cStr)+cStr.length,cPage.length) 
  	      IP = cPage.left(cPage.indexOf("</body>"))	

	   elseif cUse == "WEBCOGS"
         cStr = "Your IP address is:"
      	cPage = cPage.substring(cPage.indexOf(cStr)+cStr.length+16,cPage.length)
         IP = cPage.left(cPage.indexOf("</b>"))

		elseif cUse == "UCI"
         cStr = "Here is your IP Address: <span style='color: #d02;'>"
      	cPage = cPage.substring(cPage.indexOf(cStr)+cStr.length,cPage.length)
         IP = cPage.left(cPage.indexOf("</span>"))

		elseif cUse == "FAQS"
      	cStr = "Your IP address is: "
      	cPage = cPage.substring(cPage.indexOf(cStr)+cStr.length,cPage.length)
         IP = cPage.left(cPage.indexOf(" </p>"))

		elseif cUse == "UPENN"
         cStr = "<font color='black'>"
      	cPage = cPage.substring(cPage.indexOf(cStr)+cStr.length,cPage.length)
         IP = cPage.left(cPage.indexOf("<BR>"))

			cStr = "Your host name is: <br><br> <font color='black'>"
      	cPage = cPage.substring(cPage.indexOf(cStr)+cStr.length,cPage.length)
         RDNS = cPage.left(cPage.indexOf("<BR>"))

		elseif cUse == "BIOMED"
			cStr = "<b>"
      	cPage = cPage.substring(cPage.indexOf(cStr)+cStr.length,cPage.length)
         IP = cPage.left(cPage.indexOf("</b>"))

		elseif cUse == "SUNY"
			cStr = "Your Name is</td>"
      	cPage = cPage.substring(cPage.indexOf(cStr)+cStr.length+19,cPage.length)
         RDNS = cPage.left(cPage.indexOf("</td>"))

         cStr = "Your IP Number is</td>"
      	cPage = cPage.substring(cPage.indexOf(cStr)+cStr.length+19,cPage.length)
         IP = cPage.left(cPage.indexOf("</td>"))

		elseif cUse == "TRUESHOT"
         cStr = "Your IP Address is: "
      	IP = cPage.substring(cPage.indexOf(cStr)+cStr.length,cPage.length)

		elseif cUse == "ALLDBASE"
         cStr = "Your IP Address is: "
      	cPage = cPage.substring(cPage.indexOf(cStr)+cStr.length,cPage.length)
			IP = cPage.left(cPage.indexOf("</i>"))

	   elseif cUse == "AUTOTRAKER"
         cStr = "Your IP Address is: "
      	cPage = cPage.substring(cPage.indexOf(cStr)+cStr.length,cPage.length)
			IP = cPage.left(cPage.indexOf("</i>"))

	   elseif cUse == "AUTOCONTROLLER"
         cStr = "Your IP Address is: "
      	cPage = cPage.substring(cPage.indexOf(cStr)+cStr.length,cPage.length)
			IP = cPage.left(cPage.indexOf("</i>"))

		elseif cUse == "RIGGORY"
         cStr = "Your IP Address is: "
      	cPage = cPage.substring(cPage.indexOf(cStr)+cStr.length,cPage.length)
			IP = cPage.left(cPage.indexOf("</i>"))

		else
      	? cPage

		endif

	endif

   if empty(cPage) or empty(IP)
   	cPage = "ERROR, could not get valid information from: " + cUSE
   endif

   //? RDNS
return iif(cPage.left(5)=="ERROR",cPage,IP.rightTrim())
